module ConvertCyr
integer, private, parameter:: StrLen=400

contains

function DosToWin(String)
character(len=StrLen):: DosToWin
character(len=*), intent(in):: String
integer, dimension(128:255):: DW
data DW / &
#C0, #C1, #C2, #C3, #C4, #C5, #C6, #C7, #C8, #C9, #CA, #CB, #CC, #CD, #CE, #CF,  &
#D0, #D1, #D2, #D3, #D4, #D5, #D6, #D7, #D8, #D9, #DA, #DB, #DC, #DD, #DE, #DF,  &
#E0, #E1, #E2, #E3, #E4, #E5, #E6, #E7, #E8, #E9, #EA, #EB, #EC, #ED, #EE, #EF,  &
#85, #85, #85, #A6, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85,  &
#85, #85, #85, #85, #85, #97, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85,  &
#85, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85, #85,  &
#F0, #F1, #F2, #F3, #F4, #F5, #F6, #F7, #F8, #F9, #FA, #FB, #FC, #FD, #FE, #FF,  &
#A8, #B8, #AA, #BA, #AF, #BF, #A1, #A2, #B0, #95, #B7, #B1, #B9, #A4, #98, #A0/
character(len=1) Sym
integer i, k, index
  DosToWin=String
  do i=1, len_trim(String)
    Sym=DosToWin(i:i); index=ichar(Sym)
      if (index >= 128) then
        k=DW(index); Sym=char(k)
        DosToWin(i:i)=Sym
      end if
  end do
end function DosToWin

function WinToDos(String)
character(len=StrLen):: WinToDos
character(len=*), intent(in):: String
integer, dimension(128:255):: WD
data WD / &
#B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0, #B0,  &
#B0, #B0, #B0, #B0, #B0, #F9, #B0, #C5, #FE, #B0, #B0, #B0, #B0, #B0, #B0, #B0,  &
#FF, #F6, #F7, #B0, #FD, #B0, #B3, #15, #F0, #B0, #F2, #B0, #B0, #B0, #B0, #F4,  &
#F8, #FB, #B0, #B0, #B0, #B0, #B0, #FA, #F1, #FC, #F3, #B0, #B0, #B0, #B0, #F5,  &
#80, #81, #82, #83, #84, #85, #86, #87, #88, #89, #8A, #8B, #8C, #8D, #8E, #8F,  &
#90, #91, #92, #93, #94, #95, #96, #97, #98, #99, #9A, #9B, #9C, #9D, #9E, #9F,  &
#A0, #A1, #A2, #A3, #A4, #A5, #A6, #A7, #A8, #A9, #AA, #AB, #AC, #AD, #AE, #AF,  &
#E0, #E1, #E2, #E3, #E4, #E5, #E6, #E7, #E8, #E9, #EA, #EB, #EC, #ED, #EE, #EF/
character(len=1) Sym
integer i, k, index
  WinToDos=String
  do i=1, len_trim(String)
    Sym=WinToDos(i:i); index=ichar(Sym)
      if (index >= 128) then
        k=WD(index); Sym=char(k)
        WinToDos(i:i)=Sym
     end if
  end do
end function WinToDos

end module ConvertCyr
